/*
      PARA   2001
   ----------------------------------

   :     
   {(x,y,z): X0  x  X1, Y0  y  Y1, Z0  z  Z1} 
       (x_1, y_1, z_1)  (x_2, y_2, z_2).  
   ,         
    [-1000, 1000].   PARA.EXE,  
           
      ,      - ,
           .

            
     .

           
   (. x = X0  x = X1),        
     .   x = X0,     .  YZ  
    . (X0;Y0;Z0), a  y = Y1,   .  XZ   
   . (X0;Y1;Z0).

              
     , ..     .
   .  x = X1,   Y0 <= y <= Y1  Z0 <= z <= Z1.

         / x, y  z  
          (x = 0, y = 1, z = 2).

    getSide(p)       p.
       s (0 <= s < 6) s =  + k,
     = 0, 1  2 ,     
     (X, Y  Z),  k = 0  3     ,
   . y = Y1   4 (1 + 3),  z = Z0   2 (2 + 0).

        ,    
     :
   1) s1 = s2 -    
   2) s1 = s2 + 3  s1 + 3 = s2 - 
   3) 

    "1)"
   -----------
            
     :

   d = (x_1 - x_2)^2 + (y_1 - y_2)^2 + (z_1 - z_2)^2

    "2)"
   -----------
       ,    
    .  XZ (y_1 = Y0, y_2 = Y1)     
    .

        .  XY  YZ     
   x, y  z, .   .  YZ,  x = 1, y = 2, z = 0.

      ():
   (x_1;Y0;z_1) -> (X0;Y0;z_1) -> (X0;Y1;z_1) -> (X0;Y1;z_2) -> (x_2;Y1;z_2)
   d = ( (x_1 - X0) + (Y1 - Y0) + (x_2 - X0) )^2 + (z_1 - z_2)^2;

    (o):
   (x_1;Y0;z_1) -> (X1;Y0;z_1) -> (X1;Y1;z_1) -> (X1;Y1;z_2) -> (x_2;Y1;z_2)
   d = ( (X1 - x_1) + (Y1 - Y0) + (X1 - x_2) )^2 + (z_1 - z_2)^2;

    ():
   (x_1;Y0;z_1) -> (x_1;Y0;Z0) -> (x_1;Y1;Z0) -> (x_2;Y1;Z0) -> (x_2;Y1;z_2)

    ():
   (x_1;Y0;z_1) -> (x_1;Y0;Z1) -> (x_1;Y1;Z1) -> (x_2;Y1;Z1) -> (x_2;Y1;z_2)

         1-  2-,   
    x  z.

    "3)"
   -----------
           (common = x, y  z).
     

   d = delta_common^2 + (delta_1 + delta_2)^2, 

   delta_common      -         
   delta_1  delta_2 -        
                        


   17  2001 .                            
                                            E-mail: mvalkanov@hotmail.com
*/

#include <stdio.h>
#include <values.h>

int para[3][2];
int pnt[3][2];

int getSide( int p )
{
   int i, ip, in;
   /*
      i -  
      ip, in -    -    
   */

   for ( i = 0; i < 3; i++ )
   {
      ip = i - 1; if ( ip < 0 ) ip = 2;
      in = i + 1; if ( in == 3 ) in = 0;

      if ( ( ( pnt[i][p] == para[i][0] ) || ( pnt[i][p] == para[i][1] ) ) &&
           ( ( pnt[ip][p] >= para[ip][0] ) && ( pnt[ip][p] <= para[ip][1] ) ) &&
           ( ( pnt[in][p] >= para[in][0] ) && ( pnt[in][p] <= para[in][1] ) )
         )
      {
         return ( pnt[i][p] == para[i][0] ) ? i : (i + 3);
      }
   }

   return -1;
}

int sqr( int x )
{
   return x * x;
}

int distOpp( int x, int y, int z, int p1, int p2 )
{
   int minDist = MAXINT, s, t;
   int i;

   for ( i = 0; i < 2; i++ )
   {
      s = sqr( (pnt[x][p1] - para[x][0]) + (para[y][1] - para[y][0]) +
               (pnt[x][p2] - para[x][0]) ) + sqr( pnt[z][p1] - pnt[z][p2] );

      if ( s < minDist ) minDist = s;

      s = sqr( (para[x][1] - pnt[x][p1]) + (para[y][1] - para[y][0]) +
               (para[x][1] - pnt[x][p2]) ) + sqr( pnt[z][p1] - pnt[z][p2] );

      if ( s < minDist ) minDist = s;

      t = x; x = z; z = t;
   }

   return minDist;
}

int findDist( int s1, int s2 )
{
   if ( s1 == s2 )
   {
      return sqr( pnt[0][0] - pnt[0][1] ) +
             sqr( pnt[1][0] - pnt[1][1] ) +
             sqr( pnt[2][0] - pnt[2][1] );
   }

   if ( s1 == s2 + 3 )
   {
      int x, y, z, p1, p2;

      y = s2 % 3;
      x = y - 1; if ( x < 0 ) x = 2;
      z = y + 1; if ( z == 3 ) z = 0;

      p1 = 1; p2 = 0;

      return distOpp( x, y, z, p1, p2 );
   }
   else
   if ( s2 == s1 + 3 )
   {
      int x, y, z, p1, p2;

      y = s1 % 3;
      x = y - 1; if ( x < 0 ) x = 2;
      z = y + 1; if ( z == 3 ) z = 0;

      p1 = 0; p2 = 1;

      return distOpp( x, y, z, p1, p2 );
   }
   else
   {
      int common;
      int delta_common, delta_1, delta_2;

      common = 0; while ( ( common == (s1 % 3) ) || ( common == (s2 % 3) ) ) ++common;
      delta_common = pnt[common][0] - pnt[common][1];

      if ( s2 >= 3 )
         delta_1 = para[s2 % 3][1] - pnt[s2 % 3][0];
      else
         delta_1 = pnt[s2][0] - para[s2][0];

      if ( s1 >= 3 )
         delta_2 = para[s1 % 3][1] - pnt[s1 % 3][1];
      else
         delta_2 = pnt[s1][1] - para[s1][0];

      return sqr( delta_common ) + sqr( delta_1 + delta_2 );
   }
}

int main( void )
{
   int s1, s2;
   int dist;

   FILE * f = fopen( "PARA.INP", "r" );
   fscanf( f, "%d %d %d %d %d %d", para[0] + 0, para[0] + 1, para[1] + 0, para[1] + 1, para[2] + 0, para[2] + 1 );
   fscanf( f, "%d %d %d %d %d %d", pnt[0] + 0, pnt[1] + 0, pnt[2] + 0, pnt[0] + 1, pnt[1] + 1, pnt[2] + 1 );
   fclose(f);

   dist = -1;

   if ( ( ( s1 = getSide(0) ) != -1 ) && ( ( s2 = getSide(1) ) != -1 ) )
   {
      dist = findDist( s1, s2 );
   }

   f = fopen( "PARA.OUT", "w" );
   fprintf( f, "%d", dist );
   fclose(f);

   return 0;
}

