/* Input goes like this : N; x1 y1; .. ;xN yN
  7
  68  90
  10  14
  234 14
  106 36
  106 68
  180 68
  180 80

		         	        ================
        			          	 
                          ================
   	    ( -  , Te - )

      (   )  
         ,     
    ,         
       .  ,       
    ,        .
    ,          
   .          
 3 <= n < 50,         .    
    -      ,   - 
 10000,         .   
  ,    .

 :

          .   
 ?          
         .   
    -        .     
            -  B,
          
 A * B.     ,    
        P[b] .. P[e].

             e-1
   F(b,e) =      F(b,i) * F(i,e),    (b,i,e)  
            i=b+1                        

             F(1,n).
           
 F[][],              
         .
        
  (b,i,e)    .   
    -      (b,i)  (i,e)
         -    
       .    
           (b,i)  (i,e)   
 .      ,  ,  
     ,  ,    
              .
        O(N*N*N*N),   -
        ( N*N ), 
         N  
             .
         ?  ,   
  F(b,e)        P[b]   P[e]  
                .
            
   long ,       20 , 
        .

							    
							   petko_m@yahoo.com
							   
*/
#include <math.h>
#include <fstream.h>

#define max2(a,b) (a > b ? a : b)
#define min2(a,b) (a < b ? a : b)

#define SMALL_EPS 0.000001
#define EPS 0.0001
#define MAX 50

struct Tpoint {
  double x,y;
};

int    n;
Tpoint p[MAX];
long   tri[MAX][MAX];
double maxx;

void readdata()
{
   int  i;
   char buf[81];

   ifstream fin("tri.cpp");

   fin.getline(buf,81);
   fin >> n;
   for(i=1;i<=n;i++)
   {
      fin >> p[i].x >> p[i].y;
      maxx = max2(maxx,p[i].x);
   }

   p[n+1] = p[1]; //       
   p[0] = p[n];

   fin.close();
}

int zero(double v)
{
   return fabs(v) < EPS;
}

int lineequation(Tpoint p1,Tpoint p2,Tpoint p)
{
   double res;

   res = (p2.y - p1.y) * p.x +
	 (p1.x - p2.x) * p.y +
	 (p1.y * p2.x - p2.y * p1.x);

   if(zero(res)) return 0;
   if(res > 0) return 1;
   if(res < 0) return -1;
}

int crosssegseg(Tpoint p1,Tpoint p2,Tpoint p3,Tpoint p4)
{
   int s1,s2,s3,s4;

   s1 = lineequation(p1,p2,p3); s2 = lineequation(p1,p2,p4);
   s3 = lineequation(p3,p4,p1); s4 = lineequation(p3,p4,p2);

   return s1 * s2 == -1 && s3 * s4 == -1;
}

int isline(Tpoint a,Tpoint b,Tpoint c)
{
   return zero((c.y - a.y) * (b.x - a.x) - (c.x - a.x) * (b.y - a.y));
}

int partofline(Tpoint a,Tpoint b,Tpoint c)
{
   return isline(a,b,c) &&
	  (c.x >= min2(a.x,b.x) && c.x <= max2(a.x,b.x)) &&
	  (c.y >= min2(a.y,b.y) && c.y <= max2(a.y,b.y));
}

int inpoly(Tpoint a)
{
   Tpoint  b;
   int     how,i;

   how = 0;
   b.x = maxx + 10; b.y = a.y + SMALL_EPS;

   for(i=1;i<=n;i++)
   {
      if(partofline(p[i],p[i+1],a)) return 1;
      how += crosssegseg(p[i],p[i+1],a,b);
   }

   return how % 2;
}

//     ""  (b,s,e)
int validcut(int b,int s,int e)
{
   int    i;
   Tpoint m;

   //    (b,s,e)    
   for(i=1;i<=n;i++)
     if(crosssegseg(p[i],p[i+1],p[b],p[s]) ||
	crosssegseg(p[i],p[i+1],p[s],p[e]))
       return 0;

   //     
   m.x = (p[b].x + p[s].x) / 2;
   m.y = (p[b].y + p[s].y) / 2;
   if(!inpoly(m)) return 0;

   m.x = (p[e].x + p[s].x) / 2;
   m.y = (p[e].y + p[s].y) / 2;
   if(!inpoly(m)) return 0;

   return 1;
}

//   F(b,e)
long counttri(int b,int e)
{
   int  i;
   long val;

   // ako    -    
   if(b + 1 == e) return 1;
   if(tri[b][e] != -1) return tri[b][e]; //    ?

   val = 0;
   for(i=b+1;i<=e-1;i++)
     if(validcut(b,i,e))
       val += counttri(b,i) * counttri(i,e);

   tri[b][e] = val;
   return val;
}

void solve()
{
   int i,j;

   //   F  
   for(i=1;i<=n;i++)
     for(j=1;j<=n;j++)
       tri[i][j] = -1;

   cout << counttri(1,n) << endl;
}

void main()
{
   readdata();
   solve();
}