(*
1 4
4 5
B 2 16 99
P 6 32 13
P 2 87 4
P 38 96 49
1 2 4
1 3 40
2 3 75
2 4 76
3 4 77


         
http://olympiads.win.tue.nl/ioi/ioi99/contest/index.html

			IOI'99 - Traffic Lights
:
      .     
   -         . 
        ,      
   .     ,     , 
  ,      (     
         ).       
    ,         
 ,          
  ,        .
  ,          
.     ,      ,  
      . (    1 
       ,        )

:
2 <= N <= 300  N    ,     
       [1..N]
1 <=  <= 14000        
1 <= Lij <= 100  Lij       
  i   j
1 <= TiC <= 100  TiC        i 
 C (C   'B'    'P'  )
1 <= RiC <= TiC  RiC  ,      
 i      C

:
1-      -    
2-      - N  M
 N        
.. (i+2)-         i- 
 : Ci, RiC, TiB, TiP  Ci   'B',  'P',  
      i
       ,       
 : i j Lij  i  j    ,  Lij   
    

:
     (      ),
       0
     ,  
 1-          
 2-          
(   1-    ,  - )


:
   ,         
    (Dijkstra algorithm)   ,   
 .         ,   
  .

  :
	for v in V do D[v] := A[s,v];
	D[s] := 0; T := V \ {s}
	while not (empty T) do begin
	  u := r in T : D[r]=min{D[p]:p in T}
	  T := T \ {u}
{*}	  for v in T do D[v] := min( D[v], D[u]+A[u,v] )
	end;
 [i,j]    ; V    ,  s   
.         {*}:
{*}	  for v in T do D[v] := min( D[v], D[u]+A[u,v]+Wait(D[v],u,v) )
 Wait(Time,i,j)         
  i  j        Time .
 Wait       [0,) - 0   
           
  .  Wait        
,      ()     i 
e       ()     j 
           
        .

-     .    3  :
1. InPut -    
2. Go -    Dijkstra
3. OutPut -      .

          , 
           
 .

 ,       Wait ( -).


10.I.2001					 
*)

{$G+,Q-,R-,S-,M 16384,0,655360}
program Lights;
const
     InFile                     = 'lights.pas';
     OutFile                    = '';
     MaxN                       = 300;
     Blue                       = False;
     Purple                     = True;
     Infinity                   = 123456789;
type
    PList                       = ^TList;
    TList                       = record
                                    Key, Leng : Integer;
                                    Next      : PList;
                                  end;
   TJunc                        = record
                                    Initial : Boolean;
                                    Remain  : Integer;
                                    Time    : array[Blue..Purple] of Integer;
                                  end;

var
   Neib                         : array[1..MaxN] of PList;
   Info                         : array[1..MaxN] of TJunc;
   Dist, Prev                   : array[0..MaxN] of LongInt;
   N, Beg, Fin                  : Integer;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure AddNeib(I, J, L : Integer);
var
   P                            : PList;
begin
  New(P);
  P^.Key := J;
  P^.Leng := L;
  P^.Next := Neib[I];
  Neib[I] := P;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
   F                            : Text;
   I, J, M, K, L                : Integer;
   C                            : Char;
begin
  FillChar(Info, SizeOf(Info), 0);
  for I := 1 to MaxN do Neib[I] := nil;

  Assign(F, InFile); ReSet(F);
  ReadLn(F); {       .pas}
  ReadLn(F, Beg, Fin);
  ReadLn(F, N, M);
  for I := 1 to N do with Info[I] do begin
    Read(F, C);
    Initial := C = 'P';
    ReadLn(F, Remain, Time[Blue], Time[Purple]);
  end;
  for K := 1 to M do begin
    ReadLn(F, I, J, L);
    AddNeib(I, J, L);
    AddNeib(J, I, L);
  end;
  Close(F);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
function Wait(I, J, PassedTime : LongInt) : LongInt;
var
   Cur, Li, Lj, Tmp             : LongInt;
   Ci, Cj                       : Boolean;
begin
  if (Info[I].Initial xor Info[J].Initial) and
     (Info[I].Remain = Info[J].Remain) and
     (Info[I].Time[Blue] = Info[J].Time[Purple]) and
     (Info[I].Time[Purple] = Info[J].Time[Blue]) then begin
        Wait := Infinity;
        Exit;
     end;

  with Info[I] do begin Ci := Initial; Li := Remain; end;
  with Info[J] do begin Cj := Initial; Lj := Remain; end;
  Cur := 0;

  repeat
    if Li < Lj then Tmp := Li else Tmp := Lj;
    if (Ci = Cj) and (Cur + Tmp > PassedTime) then begin
      if Cur < PassedTime then Wait := 0
                          else Wait := Cur - PassedTime;
      Exit;
    end;
    Inc(Cur,Tmp);
    Dec(Li,Tmp); if Li = 0 then begin Ci := not Ci; Li := Info[I].Time[Ci]; end;
    Dec(Lj,Tmp); if Lj = 0 then begin Cj := not Cj; Lj := Info[J].Time[Cj]; end;
  until False;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
   K, L                         : LongInt;
   Used                         : array[1..MaxN] of Boolean;
   P                            : PList;
begin
  FillChar(Used, SizeOf(Used), 0);
  for K := 0 to MaxN do Dist[K] := Infinity;

  K := Beg; Dist[K] := 0; Prev[K] := 0;
  repeat
    Used[K] := True;
    P := Neib[K];
    while P <> nil do begin
      L := Dist[K] + P^.Leng + Wait(K,P^.Key,Dist[K]);
      if L < Dist[P^.Key] then begin
        Prev[P^.Key] := K;
        Dist[P^.Key] := L;
      end;
      P := P^.Next;
    end;

    K := 0;
    for L := 1 to N do
      if (not Used[L]) and (Dist[L] < Dist[K]) then K := L;
  until (K = 0) or (K = Fin);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
   F                            : Text;
   Ans                          : array[1..MaxN] of Integer;
   K, I                         : Integer;
begin
  Assign(F, OutFile); ReWrite(F);
  if Dist[Fin] >= Infinity then WriteLn(F, 0) else begin
    K := 0; I := Fin;
    repeat
      Inc(K);
      Ans[K] := I;
      I := Prev[I];
    until I = 0;

    WriteLn(F, Dist[Fin]);
    for I := K downto 2 do Write(F, Ans[I], ' ');
    WriteLn(F, Ans[1]);
  end;
  Close(F);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  Go;
  OutPut;
end.


